from sys import stdin, argv
from math import log
from collections import defaultdict
from string import ascii_lowercase
from random import shuffle

freq = defaultdict(float)

total = 0
for row in open(argv[1],'r').readlines():
    freq[ row[:4] ] = float( row[5:] )
    total += float( row[5:] )

for t in freq: freq[t] /= total

raw_text = stdin.read().lower()
text = ''
for x in raw_text:
    if x.isalpha(): text += x



def prekvapenie(text):
    surprise = 0.
    for i in range( len(text)-3 ): surprise -= log( max( freq[ text[i:i+4] ], 1e-8 ) )
    return surprise

def desifruj(kluc):
    result = ''
    for x in text: result += kluc[x]
    return result

def nahodny_kluc():
    perm = [ x for x in ascii_lowercase ]
    shuffle(perm)
    kluc = {}
    for x,y in zip(ascii_lowercase,perm): kluc[x] = y
    return kluc

def vylepsi_kluc(kluc):
    teraz = prekvapenie( desifruj(kluc) )
    best, bx, by = teraz, None, None
    for x in ascii_lowercase:
        for y in ascii_lowercase:
            if x < y:
                kluc[x], kluc[y] = kluc[y], kluc[x]
                toto = prekvapenie( desifruj(kluc) )
                if toto < best: best, bx, by = toto, x, y
                kluc[x], kluc[y] = kluc[y], kluc[x]
    if bx is not None:
        kluc[bx], kluc[by] = kluc[by], kluc[bx]
        return True
    return False

gbest = 1e30
while True:
    kluc = nahodny_kluc()
    while vylepsi_kluc(kluc):
        teraz = prekvapenie( desifruj(kluc) )
        if teraz < gbest:
            gbest = teraz
            print('{:.4f} {}'.format(gbest,desifruj(kluc)[:80]))


